/**
 * @file FootyViewKey.cpp
 * @brief ̃t@CŃL[{[hbZ[W̏s܂B
 * @author Shinji Watanabe
 * @date Nov.08.2008
 */

#include "FootyView.h"
#include "KeyboardState.h"

//-----------------------------------------------------------------------------
/**
 * CFootyView::OnChar
 * @brief łꂽƂAhLgXVčĕ`悷
 * @param c ͂ꂽꕶ
 * @note WM_CHARĂ΂܂B
 */
void CFootyView::OnChar(wchar_t c)
{
	// WM_IME_COMPOSITION̕ALZ
	if (m_nIgnoreKey > 0){
		m_nIgnoreKey -= sizeof(wchar_t);
		return;
	}

	// ȕ񂩃`FbN
	if ((0x20 <= c && c <= 0x7e) ||
		(0xa1 <= c && c <= 0xdf)){

		// ꕶ}郋[`Ăяo
		CFootyDoc::RedrawType nNeedRedraw = m_pDocuments->InsertChar(c);

		// Lbgʒu\ʒuݒ
		size_t nBeforeFirstVisibleColumn = m_nFirstVisibleColumn;
		CEthicLine cBeforeFirstVisibleLine = *m_pDocuments->GetFirstVisible(m_nViewID);

		AdjustVisibleLine();
		AdjustVisiblePos();

		// tO𒲐
		if (nBeforeFirstVisibleColumn != m_nFirstVisibleColumn ||
			*m_pDocuments->GetFirstVisible(m_nViewID) != cBeforeFirstVisibleLine)
			nNeedRedraw = CFootyDoc::REDRAW_ALL;

		// ĕ`
		if (nNeedRedraw == CFootyDoc::REDRAW_ALL)
			Refresh();
		else
			LineChangedRefresh();

		// Cxgʒm
		m_pDocuments->SendTextModified(MODIFIED_CAUSE_CHAR);
	}
	
}

//-----------------------------------------------------------------------------
/**
 * CFootyView::OnImeComposition
 * @brief IMẼbZ[WĂƂ̏
 * @param lParam bZ[WLPARAM̂܂܈p
 */
void CFootyView::OnImeComposition(LPARAM lParam)
{
	if (lParam & GCS_RESULTSTR) 										// ϊ₪m肳ꂽƂ
	{
		// 錾
		unsigned long dwSize;											// IME̕ϊ񒷂
		HIMC hImc = ImmGetContext(m_hWnd);								// IMẼnh
		
		// IMEϊ擾
		if (!hImc)return;
		dwSize = ImmGetCompositionStringW(hImc,GCS_RESULTSTR,NULL,0);	// m蕶̒擾
		std::wstring strImeString;
		strImeString.resize(dwSize/sizeof(wchar_t));
		ImmGetCompositionStringW(hImc,GCS_RESULTSTR,(LPVOID)strImeString.c_str(),dwSize);
		
		// 擾}
		CFootyDoc::RedrawType nNeedRedraw = m_pDocuments->InsertString(strImeString.c_str(),true,true);

		// LZʂ
		m_nIgnoreKey += dwSize;											// OnCharŃLZ

		// Lbgʒu\ʒuݒ
		size_t nBeforeFirstVisibleColumn = m_nFirstVisibleColumn;
		CEthicLine cBeforeFirstVisibleLine = *m_pDocuments->GetFirstVisible(m_nViewID);

		AdjustVisibleLine();
		AdjustVisiblePos();

		// tO𒲐
		if (nBeforeFirstVisibleColumn != m_nFirstVisibleColumn ||
			*m_pDocuments->GetFirstVisible(m_nViewID) != cBeforeFirstVisibleLine)
			nNeedRedraw = CFootyDoc::REDRAW_ALL;

		// ĕ`
		if (nNeedRedraw == CFootyDoc::REDRAW_ALL)
			Refresh();
		else
			LineChangedRefresh();

		// Cxgʒm
		m_pDocuments->SendTextModified(MODIFIED_CAUSE_IME);
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief IMENGXgƂ̏
 * @param wParam bZ[WWPARAMp
 * @param lParam bZ[WLPARAMp
 * @return bZ[WԂׂLRESULTl
 */
LRESULT CFootyView::OnImeRequest(WPARAM wParam,LPARAM lParam)
{
	LRESULT lReturn = false;
	static int nTextLength = 0;
	if (wParam == IMR_RECONVERTSTRING && m_pDocuments->IsSelecting()){		// ĕϊv
		RECONVERTSTRING* pReConvStr = (RECONVERTSTRING*)lParam;
		std::wstring wstrSelText;
		m_pDocuments->GetSelText(&wstrSelText);
		if (!pReConvStr){													// Ăяo
			nTextLength = WideCharToMultiByte(CP_ACP,0,wstrSelText.c_str(),
				-1,NULL,0,NULL,NULL) - 1;									// NULLobt@܂ނ̂ň
		}
		else{																// ڂ̌Ăяo
			// RECONVERTSTRING\̂𖄂߂
			LPSTR lpsz = (LPSTR)pReConvStr + sizeof(RECONVERTSTRING);
			WideCharToMultiByte(CP_ACP,0,wstrSelText.c_str(),
				-1,lpsz,nTextLength,NULL,NULL);
			pReConvStr->dwStrLen = nTextLength;
			pReConvStr->dwStrOffset = sizeof(RECONVERTSTRING);
			pReConvStr->dwTargetStrOffset = 0;
			pReConvStr->dwTargetStrLen = nTextLength;
			pReConvStr->dwCompStrOffset = 0;
			pReConvStr->dwCompStrLen = nTextLength;
		}
		lReturn = sizeof(RECONVERTSTRING) + nTextLength;
	}
	return lReturn;
}



#define START_MOVEKEY	nNeedRedraw = CFootyDoc::REDRAW_CURMOVE;			\
						if (cKeyStates.IsShiftPushed()){					\
							if (!m_pDocuments->IsSelecting())				\
								m_pDocuments->SetSelectStart();				\
						}													\
						else{												\
							if (m_pDocuments->IsSelecting()){				\
								m_pDocuments->UnSelect();					\
								nNeedRedraw = CFootyDoc::REDRAW_ALL;		\
							}												\
						}

#define END_MOVEKEY		if (cKeyStates.IsShiftPushed()){					\
							m_pDocuments->SetSelectEndNormal();				\
							nNeedRedraw = CFootyDoc::REDRAW_SELCHANGED;		\
						}													\
						m_pDocuments->SendMoveCaretCallBack();

	

//-----------------------------------------------------------------------------
/**
 * @brief L[ꂽƂɌĂ΂܂B
 * @param nKeyCode bZ[WĂяoꂽƂ̃L[R[h܂
 * @return ̊֐sƂɂtrueAłȂƂfalseԂ܂
 */
bool CFootyView::OnKeyDown(int nKeyCode)
{
	// 錾
	size_t i;
	bool bDontAdjustLine = false;
	CFootyDoc::RedrawType nNeedRedraw = CFootyDoc::REDRAW_FAILED;
	CFootyLine::EthicInfo stEthicInfo;
	size_t nPosition;
	CKeyBoardState cKeyStates(m_bShiftLocked);
	LinePt pLineBefore = m_pDocuments->GetCaretPosition()->GetLinePointer();
	size_t nPosBefore = m_pDocuments->GetCaretPosition()->GetPosition();
	size_t nBeforeFirstVisibleColumn = m_nFirstVisibleColumn;
	CEthicLine cBeforeFirstVisibleLine = *m_pDocuments->GetFirstVisible(m_nViewID);
	
	// L[ɂďꍇ킯
	switch(nKeyCode)
	{

//̃L[
	case VK_UP:
		if (cKeyStates.IsControlPushed()){
			m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicBack(1);
			bDontAdjustLine = true;
		}
		else
		{
			START_MOVEKEY
			// \ʒuXV
			if (*m_pDocuments->GetFirstVisible(m_nViewID) == *m_pDocuments->GetCaretPosition())
			{
				stEthicInfo = m_pDocuments->GetCaretPosition()->GetLinePointer()->CalcEthicLine
					(m_pDocuments->GetCaretPosition()->GetPosition(),m_pDocuments->GetLapelColumn(),
					m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode());
				m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicBack(1);
			}
			// Lbgړ
			m_pDocuments->GetCaretPosition()->MoveLineBackwardEthic(m_pDocuments->GetLineList(),1,
				m_pDocuments->GetLapelColumn(),
				m_pDocuments->GetTabLen(),
				m_pDocuments->GetLapelMode());
			END_MOVEKEY
		}
		break;

//̃L[
	case VK_DOWN:
		if (cKeyStates.IsControlPushed()){
			m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),1);
			bDontAdjustLine = true;
		}
		else{
			START_MOVEKEY
			// Lbgړ
			m_pDocuments->GetCaretPosition()->MoveLineForwardEthic(m_pDocuments->GetLineList(),1,
				m_pDocuments->GetLapelColumn(),
				m_pDocuments->GetTabLen(),
				m_pDocuments->GetLapelMode());
			// \ʒuXV
			stEthicInfo = m_pDocuments->GetCaretPosition()->GetLinePointer()->CalcEthicLine
				(m_pDocuments->GetCaretPosition()->GetPosition(),m_pDocuments->GetLapelColumn(),
				m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode());
			if (m_pDocuments->GetFirstVisible(m_nViewID)->GetLinePointer()->GetOffset() + 
				m_pDocuments->GetFirstVisible(m_nViewID)->GetEthicNum() + m_nVisibleLines ==
				m_pDocuments->GetCaretPosition()->GetLinePointer()->GetOffset() + stEthicInfo.m_nEthicLine + 1)
				m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),1);
			END_MOVEKEY
		}
		break;

//ẼL[
	case VK_RIGHT:
		START_MOVEKEY
		// ʒuړ
		if (cKeyStates.IsControlPushed())
			m_pDocuments->MoveWordForward();
		else{
			// TQ[gyAǂ`FbN
			CEditPosition *pCaretPos = m_pDocuments->GetCaretPosition();
			if (CFootyLine::IsSurrogateLead(pCaretPos->GetLinePointer()->GetLineData()[pCaretPos->GetPosition()]))
				pCaretPos->MoveColumnForward(m_pDocuments->GetLineList(),2);
			else
				pCaretPos->MoveColumnForward(m_pDocuments->GetLineList(),1);
		}
		// \ʒuXV
		stEthicInfo = m_pDocuments->GetCaretPosition()->GetLinePointer()->CalcEthicLine
			(m_pDocuments->GetCaretPosition()->GetPosition(),m_pDocuments->GetLapelColumn(),
			m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode());
		if (stEthicInfo.m_nEthicColumn == m_nFirstVisibleColumn + m_nVisibleColumns)
			m_nFirstVisibleColumn ++;
		if (m_pDocuments->GetFirstVisible(m_nViewID)->GetLinePointer()->GetOffset() + 
			m_pDocuments->GetFirstVisible(m_nViewID)->GetEthicNum() + m_nVisibleLines ==
			m_pDocuments->GetCaretPosition()->GetLinePointer()->GetOffset() + stEthicInfo.m_nEthicLine + 1)
			m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),1);
		END_MOVEKEY
		break;

//̃L[
	case VK_LEFT:
		START_MOVEKEY
		// \ʒuXV
		stEthicInfo = m_pDocuments->GetCaretPosition()->GetLinePointer()->CalcEthicLine
			(m_pDocuments->GetCaretPosition()->GetPosition(),m_pDocuments->GetLapelColumn(),
			m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode());
		if (stEthicInfo.m_nEthicColumn != 0 &&
			stEthicInfo.m_nEthicColumn == m_nFirstVisibleColumn)
			m_nFirstVisibleColumn --;
		// ʒuړ
		if (cKeyStates.IsControlPushed())
			m_pDocuments->MoveWordBack();
		else{
			// TQ[gyAǂ`FbN
			CEditPosition *pCaretPos = m_pDocuments->GetCaretPosition();
			if (CFootyLine::IsSurrogateTail(pCaretPos->GetLinePointer()->GetLineData()[pCaretPos->GetPosition()-1]))
				pCaretPos->MoveColumnBackward(m_pDocuments->GetLineList(),2);
			else
				pCaretPos->MoveColumnBackward(m_pDocuments->GetLineList(),1);
		}
		END_MOVEKEY
		break;

//y[W_EL[
	case VK_NEXT:
		START_MOVEKEY
		// \ʒuXV
		m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),m_nVisibleLines);
		// J[\ړ
		for (i=0;i<m_nVisibleLines;i++){
			m_pDocuments->GetCaretPosition()->MoveLineForwardEthic(m_pDocuments->GetLineList(),1,
				m_pDocuments->GetLapelColumn(),
				m_pDocuments->GetTabLen(),
				m_pDocuments->GetLapelMode());
		}
		END_MOVEKEY
		nNeedRedraw = CFootyDoc::REDRAW_ALL;
		break;

//y[WAbvL[
	case VK_PRIOR:
		START_MOVEKEY
		// \ʒuXV
		m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicBack(m_nVisibleLines);
		// J[\ړ
		for (i=0;i<m_nVisibleLines;i++){
			m_pDocuments->GetCaretPosition()->MoveLineBackwardEthic(m_pDocuments->GetLineList(),1,
				m_pDocuments->GetLapelColumn(),
				m_pDocuments->GetTabLen(),
				m_pDocuments->GetLapelMode());
		}
		END_MOVEKEY
		nNeedRedraw = CFootyDoc::REDRAW_ALL;
		break;

//HomeL[ꂽƂ
	case VK_HOME:
		START_MOVEKEY
		if (cKeyStates.IsControlPushed())	// CtrlL[Ă̂ōŏ
		{
			m_pDocuments->GetCaretPosition()->SetPosition(m_pDocuments->GetLineList(), 0, 0 );
		}
		else								// CtrlL[ĂȂ
		{
			stEthicInfo = pLineBefore->CalcEthicLine( nPosBefore, m_pDocuments->GetLapelColumn(), m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode() );

			if ( m_bAutoIndentMode && stEthicInfo.m_nEthicLine == 0)
			{
				size_t nIndentPos = pLineBefore->CalcAutoIndentPos( pLineBefore->GetLineLength() );
				if ( nIndentPos == nPosBefore )
				{
					nPosition = 0;
				}
				else
				{
					nPosition = nIndentPos;
				}
			}
			else
			{
				nPosition = pLineBefore->CalcRealPosition(stEthicInfo.m_nEthicLine,0,m_pDocuments->GetLapelColumn(), m_pDocuments->GetTabLen(), m_pDocuments->GetLapelMode() );
			}

			m_pDocuments->GetCaretPosition()->SetPosition( pLineBefore, nPosition);
		}
		END_MOVEKEY
		break;

//EndL[ꂽƂ
	case VK_END:
		START_MOVEKEY
		if (cKeyStates.IsControlPushed())	// CtrlL[Ă̂ōŌ
		{
			LinePt pLastLine = m_pDocuments->GetLastLine();
			m_pDocuments->GetCaretPosition()->SetPosition( pLastLine, pLastLine->GetLineLength() );
		}
		else								// CtrlL[ĂȂ
		{
			stEthicInfo = pLineBefore->CalcEthicLine( nPosBefore, m_pDocuments->GetLapelColumn(), m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode() );
			nPosition = pLineBefore->CalcRealPosition( stEthicInfo.m_nEthicLine, m_pDocuments->GetLapelColumn(), m_pDocuments->GetLapelColumn(), m_pDocuments->GetTabLen(), m_pDocuments->GetLapelMode() );
			m_pDocuments->GetCaretPosition()->SetPosition( pLineBefore, nPosition );
		}
		END_MOVEKEY
		break;

//^uL[
	case VK_TAB:
		if (m_pDocuments->IsSelecting() &&
			m_pDocuments->GetSelStart()->GetLinePointer() != 
			m_pDocuments->GetSelEnd()->GetLinePointer()){
			if (cKeyStates.IsShiftPushed())
				m_pDocuments->Unindent();
			else
				m_pDocuments->Indent();
			nNeedRedraw = CFootyDoc::REDRAW_ALL;
		}
		else{
			nNeedRedraw = m_pDocuments->InsertChar(L'\t');
			m_pDocuments->SendTextModified(MODIFIED_CAUSE_TAB);
		}
		
		break;

//obNXy[X
	case VK_BACK:
		nNeedRedraw = m_pDocuments->OnBackSpace();
		m_pDocuments->SendTextModified(MODIFIED_CAUSE_BACKSPACE);		
		break;

//DelL[
	case VK_DELETE:
		nNeedRedraw = m_pDocuments->OnDelete();
		m_pDocuments->SendTextModified(MODIFIED_CAUSE_DELETE);
		break;

//InsertL[
	case VK_INSERT:
		/*Lbg͕ς邪ĕ`͂Ȃ*/
		m_pDocuments->SetInsertMode(!m_pDocuments->IsInsertMode());
		CaretMove();
		break;

//EnterL[ꂽƂ
	case VK_RETURN:
		if (cKeyStates.IsControlPushed())
		{
			if (cKeyStates.IsShiftPushed())
			{
				m_pDocuments->InsertReturnDown( m_bAutoIndentMode );
			}
			else
			{
				m_pDocuments->InsertReturnUp( m_bAutoIndentMode );
			}
		}
		else m_pDocuments->InsertReturn( m_bAutoIndentMode );
		// \ʒuXV
		if (m_pDocuments->GetFirstVisible(m_nViewID)->GetLinePointer()->GetOffset() + m_nVisibleLines ==
			m_pDocuments->GetCaretPosition()->GetLinePointer()->GetOffset())
			m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),1);
		nNeedRedraw = CFootyDoc::REDRAW_ALL;
		// Cxg̒ʒm
		m_pDocuments->SendTextModified(MODIFIED_CAUSE_ENTER);		
		break;

// ESCL[őILZ܂
	case VK_ESCAPE:
		m_pDocuments->UnSelect();
		break;

//ȊÔƂ
	default:
		return false;
	}

	// Lbgʒu̍ŏI
	if (!bDontAdjustLine)AdjustVisibleLine();
	AdjustVisiblePos();

	// ĕ`tO𐮗
	if (nNeedRedraw != CFootyDoc::REDRAW_ALL){
		if (nBeforeFirstVisibleColumn != m_nFirstVisibleColumn)
			nNeedRedraw = CFootyDoc::REDRAW_ALL;
		else if (*m_pDocuments->GetFirstVisible(m_nViewID) != cBeforeFirstVisibleLine){
			if (nNeedRedraw == CFootyDoc::REDRAW_CURMOVE)
				nNeedRedraw = CFootyDoc::REDRAW_SCROLLED;
			else
				nNeedRedraw = CFootyDoc::REDRAW_ALL;
		}
	}

	// ĕ`揈
	switch(nNeedRedraw){
	case CFootyDoc::REDRAW_SCROLLED:		// XN[ꂽ
		ScrollRefresh();
		FOOTY2_PRINTF( L"Scroll redraw\n" );
		break;
	case CFootyDoc::REDRAW_CURMOVE:			// Lbgړ̂
		CaretRefresh();
		FOOTY2_PRINTF( L"cursor redraw\n" );
		break;
	case CFootyDoc::REDRAW_SELCHANGED:
		LineChangedRefresh(pLineBefore, m_pDocuments->GetCaretPosition()->GetLinePointer());
		FOOTY2_PRINTF( L"sel redraw\n" );
		break;
	case CFootyDoc::REDRAW_LINE:			// ŝݍĕ`
		LineChangedRefresh();
		FOOTY2_PRINTF( L"line redraw\n" );
		break;
	case CFootyDoc::REDRAW_ALL:				// Sĕ`
		Refresh();
		FOOTY2_PRINTF( L"all redraw\n" );
		break;
	}

	return true;
}

/*[EOF]*/
